services:
  postgres:
    image: postgres:16.0-bookworm
    environment:
      - POSTGRES_USER=${POSTGRES_ADMIN_USER}
      - POSTGRES_PASSWORD=${POSTGRES_ADMIN_PASSWORD}
      - POSTGRES_BACKEND_USER=${POSTGRES_BACKEND_USER}
      - POSTGRES_BACKEND_PASSWORD=${POSTGRES_BACKEND_PASSWORD}
      - POSTGRES_BACKEND_DB=${POSTGRES_BACKEND_DB}
      - POSTGRES_KEYCLOAK_USER=${POSTGRES_KEYCLOAK_USER}
      - POSTGRES_KEYCLOAK_PASSWORD=${POSTGRES_KEYCLOAK_PASSWORD}
      - POSTGRES_KEYCLOAK_DB=${POSTGRES_KEYCLOAK_DB}
    networks:
      tuency-service-nw:
        aliases:
          - ${POSTGRES_INTERNAL_ALIAS}
    # WARNING: Make sure your firewall is setup properly before
    # exposing any ports to the host!
    #ports:
    #    - 5432:5432
    volumes:
      - ./data:/var/lib/postgresql/data
      - ./init/setup-backend-db.sh:/docker-entrypoint-initdb.d/setup-backend-db.sh
      - ./init/setup-keycloak-db.sh:/docker-entrypoint-initdb.d/setup-keycloak-db.sh
    healthcheck:
      test: [ "CMD-SHELL", "pg_isready", "-d", "db_prod" ]
      interval: 1s
      timeout: 5s
      retries: 60
      start_period: 20s

networks:
  tuency-service-nw:
    external: true